image: node

stages:
  - test
  - build
  - deploy

test site:
  stage: test
  before_script:
    - npm install -g broken-link-checker wait-on
  script:
    - cd website
    - npm install && npm run start &
    - wait-on http://localhost:3000/ --timeout 60000
    - blc --recursive --exclude-external http://localhost:3000

vulnerabilities check:
  stage: test
  script:
    - cd website && npm install && npm run scan

build site:
  stage: build
  cache:
    key: site-package
    policy: push
    paths:
      - ./website/build
  artifacts:
    name: "$CI_JOB_NAME-$CI_COMMIT_REF_NAME"
    when: always
    expire_in: 2h20min
    paths:
      - ./website/build/missaodevops
  script:
    - cd website
    - npm install
    - npm run build
  
deploy to develop: &deploy
  stage: deploy
  variables:
    CNAME: develop-devopsjunior.surge.sh
    GIT_STRATEGY: none
  cache:
    key: site-package
    policy: pull
  before_script:
    - npm install -g surge
  script:
    - surge --project ./website/build/missaodevops --domain ${CNAME}
  environment:
    name: develop
    url: http://${CNAME}
  only:
    - develop

deploy to release: &deploy-release
  <<: *deploy
  variables:
    CNAME: $CI_COMMIT_REF_SLUG-devopsjunior.surge.sh
  environment:
    name: release/$CI_COMMIT_REF_NAME
    on_stop: turnoff
  only:
    - /^release-.*$/

turnoff:
  <<: *deploy-release
  script:
    - surge teardown ${CNAME}
  when: manual
  environment:
    name: release/$CI_COMMIT_REF_NAME
    action: stop

deploy to production:
  image: amazonlinux
  stage: deploy
  variables:
    GIT_STRATEGY: none
    S3_BUCKET: http://devopsjr.com.s3-website-us-east-1.amazonaws.com
  before_script:
    - yum install python3-pip -y
    - pip install awscli --upgrade --user && export PATH=~/.local/bin:$PATH
    - aws --version
  script:
    - aws s3 ls ${S3_BUCKET}
    - cd website/build/missaodevops && pwd && ls -ltra
    - aws s3 rm ${S3_BUCKET}/ --recursive
    - aws s3 cp . ${S3_BUCKET} --acl public-read --recursive
  environment:
    name: production
    url: http://devopsjr.com.s3-website-us-east-1.amazonaws.com
  only:
    - main